/*
 * File:          gov_cca_AbstractFramework_Module.c
 * Symbol:        gov.cca.AbstractFramework-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   implement a C extension type for a sidl extendable
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

/*
 * THIS CODE IS AUTOMATICALLY GENERATED BY THE BABEL
 * COMPILER. DO NOT EDIT THIS!
 * 
 * This file contains the implementation of a Python C
 * extension type (i.e. a Python type implemented in C).
 * This extension type provides Python interface to the
 * sidl type gov.cca.AbstractFramework.
 */


/**
 * Symbol "gov.cca.AbstractFramework" (version 0.8.5)
 * 
 *  
 * This is an interface presented by a CCA-compliant framework to access its 
 * application framing capabilities. Most of the manipulation of the 
 * underlying framework is expected to be be done with the 
 * gov.cca.BuilderService Port. This class exists as a sort of bootstrap 
 * to get a Services object necessary to retrieve Port's, including 
 * BuilderService, from the underlying framework. How the interface and 
 * the underlying framework is created is entirely unspecified and is up 
 * to the devices of the programmer and the framework provider.
 * 
 * <p>Example</p>
 * <p>
 * Here it is assumed that an instance of AbstractFramework
 * is created in the main() from some hypothetical implementation.
 * The idea is to allow a complete swap of framework choice by 
 * changing out the specified implementation class of a framework.
 * </p>
 * 
 * <code><pre>
 * // java
 * main() {
 * cca.reference.Framework fwkimpl = new cca.reference.Framework();
 * // change fwkimpl above to use different cca implementations when
 * // AbstractFramework becomes part of the standard.
 * gov.cca.AbstractFramework fwk = (gov.cca.AbstractFramework)fwkimpl;
 * gov.cca.Services svc = 
 * fwk.getServices("instance0","AppDriver",null);
 * // From here on, access all services, components, etc
 * // through svc.
 * ...
 * // when done
 * fwk.releaseServices(svc);
 * fwk.shutdownFramework();
 * }
 * 
 * // c++
 * int functionName() {
 * ::gov::sandia::ccafe::Framework fwkimpl;
 * ::gov::cca::AbstractFrameworkPtr fwk;
 * 
 * fwk = fwkimpl.getStandardFramework();
 * ::gov::cca::Services_Interface  svc = 0;
 * svc = fwk->getServices("instance0","AppDriver",0);
 * // From here on, access all services, components, etc
 * // through svc.
 * ...
 * // when done
 * fwk->releaseServices(svc);
 * svc = 0;
 * fwk->shutdownFramework();
 * 
 * // at scope exit, all memory is automatically cleaned up.
 * }
 * </pre></code>
 */
#include <Python.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifndef included_sidl_BaseClass_h
#include "sidl_BaseClass.h"
#endif
#ifndef included_sidl_ClassInfo_h
#include "sidl_ClassInfo.h"
#endif
#ifndef included_sidl_rmi_ProtocolFactory_h
#include "sidl_rmi_ProtocolFactory.h"
#endif
#ifndef included_sidl_rmi_InstanceRegistry_h
#include "sidl_rmi_InstanceRegistry.h"
#endif
#ifndef included_sidl_rmi_InstanceHandle_h
#include "sidl_rmi_InstanceHandle.h"
#endif
#ifndef included_sidl_rmi_Invocation_h
#include "sidl_rmi_Invocation.h"
#endif
#ifndef included_sidl_rmi_Response_h
#include "sidl_rmi_Response.h"
#endif
#ifndef included_sidl_rmi_ServerRegistry_h
#include "sidl_rmi_ServerRegistry.h"
#endif
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidl_io_Serializable_h
#include "sidl_io_Serializable.h"
#endif
#ifndef included_sidl_MemAllocException_h
#include "sidl_MemAllocException.h"
#endif
#ifndef included_sidl_NotImplementedException_h
#include "sidl_NotImplementedException.h"
#endif
#include "sidl_Exception.h"

#ifndef NULL
#define NULL 0
#endif

#include "sidl_thread.h"
#ifdef HAVE_PTHREAD
static struct sidl_recursive_mutex_t gov_cca__AbstractFramework__mutex= SIDL_RECURSIVE_MUTEX_INITIALIZER;
#define LOCK_STATIC_GLOBALS sidl_recursive_mutex_lock( &gov_cca__AbstractFramework__mutex )
#define UNLOCK_STATIC_GLOBALS sidl_recursive_mutex_unlock( &gov_cca__AbstractFramework__mutex )
/* #define HAVE_LOCKED_STATIC_GLOBALS (sidl_recursive_mutex_trylock( &gov_cca__AbstractFramework__mutex )==EDEADLOCK) */
#else
#define LOCK_STATIC_GLOBALS
#define UNLOCK_STATIC_GLOBALS
/* #define HAVE_LOCKED_STATIC_GLOBALS (1) */
#endif

#define gov_cca_AbstractFramework_INTERNAL 1
#include "gov_cca_AbstractFramework_Module.h"
#ifndef included_gov_cca_AbstractFramework_IOR_h
#include "gov_cca_AbstractFramework_IOR.h"
#endif
#include "sidlObjA.h"
#include "sidlPyArrays.h"
#ifdef SIDL_HAVE_NUMPY
#include "oldnumeric.h"
#elif defined(SIDL_HAVE_NUMERIC_PYTHON)
#include "Numeric/arrayobject.h"
#else
#error Neither Numeric Python nor NumPy installed
#endif
#ifndef included_sidl_Loader_h
#include "sidl_Loader.h"
#endif
#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifndef included_sidl_String_h
#include "sidl_String.h"
#endif
#ifndef included_sidl_Python_h
#include "sidl_Python.h"
#endif
#ifndef included_sidl_interface_IOR_h
#include "sidl_interface_IOR.h"
#endif
#include "sidl_rmi_NetworkException_Module.h"
#include "gov_cca_CCAException_Module.h"
#include "gov_cca_Services_Module.h"
#include "gov_cca_TypeMap_Module.h"
#include "sidl_BaseInterface_Module.h"
#include "sidl_ClassInfo_Module.h"
#include "sidl_RuntimeException_Module.h"
#include "sidl_rmi_Call_Module.h"
#include "sidl_rmi_Return_Module.h"
#include "sidl_rmi_Ticket_Module.h"
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdio.h>

/*
 * lang_inited is a boolean value showing if we have already imported all the nescessary modules
 */

static int lang_inited = 0;

static void _loadDependentMods(void) {
  PyGILState_STATE _gstate;
#if (PY_VERSION_HEX >= 0x02040000)
  _gstate = PyGILState_Ensure();
  sidl_Python_LogGILEnsure(__func__, __FILE__, __LINE__, (int)_gstate);
#endif /* Python 2.4 or later */
  gov_cca_AbstractFramework__import();
  gov_cca_CCAException__import();
  gov_cca_Services__import();
  gov_cca_TypeMap__import();
  sidl_BaseInterface__import();
  sidl_ClassInfo__import();
  sidl_RuntimeException__import();
  sidl_rmi_Ticket__import();
#if (PY_VERSION_HEX >= 0x02040000)
  PyGILState_Release(_gstate);
  sidl_Python_LogGILRelease(__func__, __FILE__, __LINE__, (int)_gstate);
#endif /* Python 2.4 or later */
}

#define LANG_SPECIFIC_INIT() if(!lang_inited) { \
  lang_inited = 1; \
  _loadDependentMods(); \
}

#ifdef WITH_RMI

/**
 * RMI connector function for the class. (no addref)
 */
struct gov_cca_AbstractFramework__object*
gov_cca_AbstractFramework__connectI(const char * url, sidl_bool ar, struct    \
  sidl_BaseInterface__object **_ex);


#endif /*WITH_RMI*/

/* Static variables to hold version of IOR */
static const int32_t s_IOR_MAJOR_VERSION = 2;
static const int32_t s_IOR_MINOR_VERSION = 0;

/* Static variables for managing EPV initialization. */
static int s_remote_initialized = 0;

static struct gov_cca__AbstractFramework__epv                                 \
  s_rem_epv__gov_cca__abstractframework;

static struct gov_cca_AbstractFramework__epv                                  \
  s_rem_epv__gov_cca_abstractframework;

static struct sidl_BaseInterface__epv s_rem_epv__sidl_baseinterface;

#ifdef WITH_RMI


/* REMOTE CAST: dynamic type casting for remote objects. */
static void* remote_gov_cca__AbstractFramework__cast(
  struct gov_cca__AbstractFramework__object* self,
  const char* name, sidl_BaseInterface* _ex)
{
  int cmp;
  void* cast = NULL;
  *_ex = NULL; /* default to no exception */
  cmp = strcmp(name, "gov.cca._AbstractFramework");
  if (!cmp) {
    (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
    cast = ((struct gov_cca__AbstractFramework__object*)self);
    return cast;
  }
  else if (cmp < 0) {
    cmp = strcmp(name, "gov.cca.AbstractFramework");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_gov_cca_abstractframework);
      return cast;
    }
  }
  else if (cmp > 0) {
    cmp = strcmp(name, "sidl.BaseInterface");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = &((*self).d_sidl_baseinterface);
      return cast;
    }
  }
  if ((*self->d_epv->f_isType)(self,name, _ex)) {
    void* (*func)(struct sidl_rmi_InstanceHandle__object*, struct             \
      sidl_BaseInterface__object**) = 
      (void* (*)(struct sidl_rmi_InstanceHandle__object*, struct              \
        sidl_BaseInterface__object**)) 
      sidl_rmi_ConnectRegistry_getConnect(name, _ex);SIDL_CHECK(*_ex);
    cast =  (*func)(((struct                                                  \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih, _ex);
  }

  return cast;
  EXIT:
  return NULL;
}

/* REMOTE DELETE: call the remote destructor for the object. */
static void remote_gov_cca__AbstractFramework__delete(
  struct gov_cca__AbstractFramework__object* self,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
  free((void*) self);
}

/* REMOTE GETURL: call the getURL function for the object. */
static char* remote_gov_cca__AbstractFramework__getURL(
  struct gov_cca__AbstractFramework__object* self, struct                     \
    sidl_BaseInterface__object* *_ex)
{
  struct sidl_rmi_InstanceHandle__object *conn = ((struct                     \
    gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
  *_ex = NULL;
  if(conn != NULL) {
    return sidl_rmi_InstanceHandle_getObjectURL(conn, _ex);
  }
  return NULL;
}

/* REMOTE ADDREF: For internal babel use only! Remote addRef. */
static void remote_gov_cca__AbstractFramework__raddRef(
  struct gov_cca__AbstractFramework__object* self,struct                      \
    sidl_BaseInterface__object* *_ex)
{
  struct sidl_BaseException__object* netex = NULL;
  /* initialize a new invocation */
  struct sidl_BaseInterface__object* _throwaway = NULL;
  struct sidl_rmi_InstanceHandle__object *_conn = ((struct                    \
    gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
  sidl_rmi_Response _rsvp = NULL;
  sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, \
    "addRef", _ex ); SIDL_CHECK(*_ex);
  /* send actual RMI request */
  _rsvp = sidl_rmi_Invocation_invokeMethod(_inv,_ex);SIDL_CHECK(*_ex);
  /* Check for exceptions */
  netex = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);
  if(netex != NULL) {
    *_ex = (struct sidl_BaseInterface__object*)netex;
    return;
  }

  /* cleanup and return */
  EXIT:
  if(_inv) { sidl_rmi_Invocation_deleteRef(_inv,&_throwaway); }
  if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp,&_throwaway); }
  return;
}

/* REMOTE ISREMOTE: returns true if this object is Remote (it is). */
static sidl_bool
remote_gov_cca__AbstractFramework__isRemote(
    struct gov_cca__AbstractFramework__object* self, 
    struct sidl_BaseInterface__object* *_ex) {
  *_ex = NULL;
  return TRUE;
}

/* REMOTE METHOD STUB:_set_hooks */
static void
remote_gov_cca__AbstractFramework__set_hooks(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ sidl_bool enable,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "_set_hooks", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(    \
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework._set_hooks.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_set_contracts */
static void
remote_gov_cca__AbstractFramework__set_contracts(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ sidl_bool enable,
  /* in */ const char* enfFilename,
  /* in */ sidl_bool resetCounters,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "_set_contracts", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(    \
      *_ex);
    sidl_rmi_Invocation_packString( _inv, "enfFilename", enfFilename,         \
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packBool( _inv, "resetCounters", resetCounters,       \
      _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework._set_contracts.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_dump_stats */
static void
remote_gov_cca__AbstractFramework__dump_stats(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ const char* filename,
  /* in */ const char* prefix,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "_dump_stats", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "filename", filename,               \
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "prefix", prefix, _ex);SIDL_CHECK(  \
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework._dump_stats.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE EXEC: call the exec function for the object. */
static void remote_gov_cca__AbstractFramework__exec(
  struct gov_cca__AbstractFramework__object* self,const char* methodName,
  sidl_rmi_Call inArgs,
  sidl_rmi_Return outArgs,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
}

/* REMOTE METHOD STUB:createTypeMap */
static struct gov_cca_TypeMap__object*
remote_gov_cca__AbstractFramework_createTypeMap(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_TypeMap__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "createTypeMap", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.createTypeMap.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str,           \
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_TypeMap__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(  \
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getServices */
static struct gov_cca_Services__object*
remote_gov_cca__AbstractFramework_getServices(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ const char* selfInstanceName,
  /* in */ const char* selfClassName,
  /* in */ struct gov_cca_TypeMap__object* selfProperties,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_Services__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "getServices", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "selfInstanceName",                 \
      selfInstanceName, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "selfClassName", selfClassName,     \
      _ex);SIDL_CHECK(*_ex);
    if(selfProperties){
      char* _url = sidl_BaseInterface__getURL((                               \
        sidl_BaseInterface)selfProperties, _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "selfProperties", _url,           \
        _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "selfProperties", NULL,           \
        _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.getServices.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str,           \
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_Services__connectI(_retval_str, FALSE, _ex);SIDL_CHECK( \
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:releaseServices */
static void
remote_gov_cca__AbstractFramework_releaseServices(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ struct gov_cca_Services__object* services,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "releaseServices", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(services){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)services,   \
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "services", _url, _ex);SIDL_CHECK(\
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "services", NULL, _ex);SIDL_CHECK(\
        *_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.releaseServices.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:shutdownFramework */
static void
remote_gov_cca__AbstractFramework_shutdownFramework(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "shutdownFramework", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.shutdownFramework.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE METHOD STUB:createEmptyFramework */
static struct gov_cca_AbstractFramework__object*
remote_gov_cca__AbstractFramework_createEmptyFramework(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct gov_cca_AbstractFramework__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "createEmptyFramework", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.createEmptyFramework.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str,           \
      _ex);SIDL_CHECK(*_ex);
    _retval = gov_cca_AbstractFramework__connectI(_retval_str, FALSE,         \
      _ex);SIDL_CHECK(*_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:addRef */
static void
remote_gov_cca__AbstractFramework_addRef(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct gov_cca__AbstractFramework__remote* r_obj = (struct                \
      gov_cca__AbstractFramework__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount++;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: addRef %p new count %d (type %s)\n",
      r_obj, r_obj->d_refcount, 
      "gov.cca._AbstractFramework Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:deleteRef */
static void
remote_gov_cca__AbstractFramework_deleteRef(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct gov_cca__AbstractFramework__remote* r_obj = (struct                \
      gov_cca__AbstractFramework__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount--;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: deleteRef %p new count %d (type %s)\n",r_obj, r_obj->d_refcount, "gov.cca._AbstractFramework Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    if(r_obj->d_refcount == 0) {
      sidl_rmi_InstanceHandle_deleteRef(r_obj->d_ih, _ex);
      free(r_obj);
      free(self);
    }
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:isSame */
static sidl_bool
remote_gov_cca__AbstractFramework_isSame(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ struct sidl_BaseInterface__object* iobj,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "isSame", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(iobj){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)iobj,       \
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "iobj", _url, _ex);SIDL_CHECK(    \
        *_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "iobj", NULL, _ex);SIDL_CHECK(    \
        *_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.isSame.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(\
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:isType */
static sidl_bool
remote_gov_cca__AbstractFramework_isType(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* in */ const char* name,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "isType", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "name", name, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.isType.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(\
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getClassInfo */
static struct sidl_ClassInfo__object*
remote_gov_cca__AbstractFramework_getClassInfo(
  /* in */ struct gov_cca__AbstractFramework__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct sidl_ClassInfo__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct                 \
      gov_cca__AbstractFramework__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation(      \
      _conn, "getClassInfo", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from gov.cca._AbstractFramework.getClassInfo.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(   \
        _be,&throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str,           \
      _ex);SIDL_CHECK(*_ex);
    _retval = sidl_ClassInfo__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(   \
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE EPV: create remote entry point vectors (EPVs). */
static void gov_cca__AbstractFramework__init_remote_epv(void)
{
  /* assert( HAVE_LOCKED_STATIC_GLOBALS ); */
  struct gov_cca__AbstractFramework__epv* epv =                               \
    &s_rem_epv__gov_cca__abstractframework;
  struct gov_cca_AbstractFramework__epv*  e0  =                               \
    &s_rem_epv__gov_cca_abstractframework;
  struct sidl_BaseInterface__epv*         e1  =                               \
    &s_rem_epv__sidl_baseinterface;

  epv->f__cast                     = remote_gov_cca__AbstractFramework__cast;
  epv->f__delete                   =                                          \
    remote_gov_cca__AbstractFramework__delete;
  epv->f__exec                     = remote_gov_cca__AbstractFramework__exec;
  epv->f__getURL                   =                                          \
    remote_gov_cca__AbstractFramework__getURL;
  epv->f__raddRef                  =                                          \
    remote_gov_cca__AbstractFramework__raddRef;
  epv->f__isRemote                 =                                          \
    remote_gov_cca__AbstractFramework__isRemote;
  epv->f__set_hooks                =                                          \
    remote_gov_cca__AbstractFramework__set_hooks;
  epv->f__set_contracts            =                                          \
    remote_gov_cca__AbstractFramework__set_contracts;
  epv->f__dump_stats               =                                          \
    remote_gov_cca__AbstractFramework__dump_stats;
  epv->f__ctor                     = NULL;
  epv->f__ctor2                    = NULL;
  epv->f__dtor                     = NULL;
  epv->f_createTypeMap             =                                          \
    remote_gov_cca__AbstractFramework_createTypeMap;
  epv->f_getServices               =                                          \
    remote_gov_cca__AbstractFramework_getServices;
  epv->f_releaseServices           =                                          \
    remote_gov_cca__AbstractFramework_releaseServices;
  epv->f_shutdownFramework         =                                          \
    remote_gov_cca__AbstractFramework_shutdownFramework;
  epv->f_createEmptyFramework      =                                          \
    remote_gov_cca__AbstractFramework_createEmptyFramework;
  epv->f_addRef                    = remote_gov_cca__AbstractFramework_addRef;
  epv->f_deleteRef                 =                                          \
    remote_gov_cca__AbstractFramework_deleteRef;
  epv->f_isSame                    = remote_gov_cca__AbstractFramework_isSame;
  epv->f_isType                    = remote_gov_cca__AbstractFramework_isType;
  epv->f_getClassInfo              =                                          \
    remote_gov_cca__AbstractFramework_getClassInfo;

  e0->f__cast                = (void* (*)(void*, const char*, struct          \
    sidl_BaseInterface__object**)) epv->f__cast;
  e0->f__delete              = (void (*)(void*, struct                        \
    sidl_BaseInterface__object**)) epv->f__delete;
  e0->f__getURL              = (char* (*)(void*, struct                       \
    sidl_BaseInterface__object**)) epv->f__getURL;
  e0->f__raddRef             = (void (*)(void*, struct                        \
    sidl_BaseInterface__object**)) epv->f__raddRef;
  e0->f__isRemote            = (sidl_bool (*)(void*, struct                   \
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e0->f__set_hooks           = (void (*)(void*, sidl_bool, struct             \
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e0->f__set_contracts       = (void (*)(void*, sidl_bool, const char*,       \
    sidl_bool, struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e0->f__dump_stats          = (void (*)(void*, const char*, const char*,     \
    struct sidl_BaseInterface__object**)) epv->f__dump_stats;
  e0->f__exec                = (void (*)(void*,const char*,struct             \
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct             \
    sidl_BaseInterface__object **)) epv->f__exec;
  e0->f_createTypeMap        = (struct gov_cca_TypeMap__object* (*)(void*,    \
    struct sidl_BaseInterface__object **)) epv->f_createTypeMap;
  e0->f_getServices          = (struct gov_cca_Services__object* (*)(void*,   \
    const char*,const char*,struct gov_cca_TypeMap__object*,struct            \
    sidl_BaseInterface__object **)) epv->f_getServices;
  e0->f_releaseServices      = (void (*)(void*,struct                         \
    gov_cca_Services__object*,struct sidl_BaseInterface__object **))          \
    epv->f_releaseServices;
  e0->f_shutdownFramework    = (void (*)(void*,struct                         \
    sidl_BaseInterface__object **)) epv->f_shutdownFramework;
  e0->f_createEmptyFramework = (struct gov_cca_AbstractFramework__object* (*)(\
    void*,struct sidl_BaseInterface__object **)) epv->f_createEmptyFramework;
  e0->f_addRef               = (void (*)(void*,struct                         \
    sidl_BaseInterface__object **)) epv->f_addRef;
  e0->f_deleteRef            = (void (*)(void*,struct                         \
    sidl_BaseInterface__object **)) epv->f_deleteRef;
  e0->f_isSame               = (sidl_bool (*)(void*,struct                    \
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **))        \
    epv->f_isSame;
  e0->f_isType               = (sidl_bool (*)(void*,const char*,struct        \
    sidl_BaseInterface__object **)) epv->f_isType;
  e0->f_getClassInfo         = (struct sidl_ClassInfo__object* (*)(void*,     \
    struct sidl_BaseInterface__object **)) epv->f_getClassInfo;

  e1->f__cast          = (void* (*)(void*, const char*, struct                \
    sidl_BaseInterface__object**)) epv->f__cast;
  e1->f__delete        = (void (*)(void*, struct                              \
    sidl_BaseInterface__object**)) epv->f__delete;
  e1->f__getURL        = (char* (*)(void*, struct                             \
    sidl_BaseInterface__object**)) epv->f__getURL;
  e1->f__raddRef       = (void (*)(void*, struct                              \
    sidl_BaseInterface__object**)) epv->f__raddRef;
  e1->f__isRemote      = (sidl_bool (*)(void*, struct                         \
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e1->f__set_hooks     = (void (*)(void*, sidl_bool, struct                   \
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e1->f__set_contracts = (void (*)(void*, sidl_bool, const char*, sidl_bool,  \
    struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e1->f__dump_stats    = (void (*)(void*, const char*, const char*, struct    \
    sidl_BaseInterface__object**)) epv->f__dump_stats;
  e1->f__exec          = (void (*)(void*,const char*,struct                   \
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct             \
    sidl_BaseInterface__object **)) epv->f__exec;
  e1->f_addRef         = (void (*)(void*,struct sidl_BaseInterface__object    \
    **)) epv->f_addRef;
  e1->f_deleteRef      = (void (*)(void*,struct sidl_BaseInterface__object    \
    **)) epv->f_deleteRef;
  e1->f_isSame         = (sidl_bool (*)(void*,struct                          \
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **))        \
    epv->f_isSame;
  e1->f_isType         = (sidl_bool (*)(void*,const char*,struct              \
    sidl_BaseInterface__object **)) epv->f_isType;
  e1->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(void*,struct     \
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  s_remote_initialized = 1;
}

/* Create an instance that connects to an existing remote object. */
static struct gov_cca_AbstractFramework__object*
gov_cca_AbstractFramework__remoteConnect(const char *url, sidl_bool ar,       \
  struct sidl_BaseInterface__object* *_ex)
{
  struct gov_cca__AbstractFramework__object* self = NULL;

  struct gov_cca__AbstractFramework__object* s0;

  struct gov_cca__AbstractFramework__remote* r_obj = NULL;
  sidl_rmi_InstanceHandle instance = NULL;
  struct gov_cca_AbstractFramework__object* ret_self = NULL;
  char* objectID = NULL;
  objectID = sidl_rmi_ServerRegistry_isLocalObject(url, _ex);
  if(objectID) {
    sidl_BaseInterface bi = (sidl_BaseInterface)                              \
      sidl_rmi_InstanceRegistry_getInstanceByString(objectID, _ex);
    return (struct gov_cca_AbstractFramework__object*)(*bi->d_epv->f__cast)(  \
      bi->d_object, "gov.cca.AbstractFramework", _ex);
  }
  instance = sidl_rmi_ProtocolFactory_connectInstance(url,                    \
    "gov.cca.AbstractFramework", ar, _ex );
  if ( instance == NULL) { return NULL; }
  self =
    (struct gov_cca__AbstractFramework__object*) malloc(
      sizeof(struct gov_cca__AbstractFramework__object));

  r_obj =
    (struct gov_cca__AbstractFramework__remote*) malloc(
      sizeof(struct gov_cca__AbstractFramework__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException( \
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(    \
      *_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__,                        \
      "gov.cca._AbstractFramework.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                                      self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    gov_cca__AbstractFramework__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_gov_cca_abstractframework.d_epv    =                                  \
    &s_rem_epv__gov_cca_abstractframework;
  s0->d_gov_cca_abstractframework.d_object = (void*) self;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__gov_cca__abstractframework;

  self->d_data = (void*) r_obj;

  ret_self = (struct gov_cca_AbstractFramework__object*) (                    \
    *self->d_epv->f__cast)(self, "gov.cca.AbstractFramework", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/* Create an instance that uses an already existing  */
/* InstanceHandel to connect to an existing remote object. */
static struct gov_cca_AbstractFramework__object*
gov_cca_AbstractFramework__IHConnect(sidl_rmi_InstanceHandle instance, struct \
  sidl_BaseInterface__object* *_ex)
{
  struct gov_cca__AbstractFramework__object* self = NULL;

  struct gov_cca__AbstractFramework__object* s0;

  struct gov_cca__AbstractFramework__remote* r_obj = NULL;
  struct gov_cca_AbstractFramework__object* ret_self = NULL;
  self =
    (struct gov_cca__AbstractFramework__object*) malloc(
      sizeof(struct gov_cca__AbstractFramework__object));

  r_obj =
    (struct gov_cca__AbstractFramework__remote*) malloc(
      sizeof(struct gov_cca__AbstractFramework__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException( \
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(    \
      *_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__,                        \
      "gov.cca._AbstractFramework.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                                      self;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    gov_cca__AbstractFramework__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s0->d_gov_cca_abstractframework.d_epv    =                                  \
    &s_rem_epv__gov_cca_abstractframework;
  s0->d_gov_cca_abstractframework.d_object = (void*) self;

  s0->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s0->d_sidl_baseinterface.d_object = (void*) self;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__gov_cca__abstractframework;

  self->d_data = (void*) r_obj;

  sidl_rmi_InstanceHandle_addRef(instance, _ex);

  ret_self = (struct gov_cca_AbstractFramework__object*) (                    \
    *self->d_epv->f__cast)(self, "gov.cca.AbstractFramework", _ex);
  if(*_ex || !ret_self) { goto EXIT; }
  return ret_self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/*
 * RMI connector function for the class.
 */

struct gov_cca_AbstractFramework__object*
gov_cca_AbstractFramework__connectI(const char* url, sidl_bool ar, struct     \
  sidl_BaseInterface__object **_ex)
{
  return gov_cca_AbstractFramework__remoteConnect(url, ar, _ex);
}


#endif /*WITH_RMI*/
#ifdef WITH_RMI

static PyObject *
pStub_AbstractFramework__connect(PyObject *_ignored, PyObject *_args,         \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object* self = NULL;
  char* url = NULL;
  struct sidl_BaseInterface__object *_exception = NULL;
  static char *_kwlist[] = {
    "url",
    NULL
  };
  int _okay;
  sidl_rmi_NetworkException__import();
  _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict, 
    "z", _kwlist,
    &url);
  if (_okay) {
#if (PY_VERSION_HEX >= 0x02040000)
    Py_BEGIN_ALLOW_THREADS
    sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    self = gov_cca_AbstractFramework__remoteConnect(url,1,&_exception);
#if (PY_VERSION_HEX >= 0x02040000)
    Py_END_ALLOW_THREADS
    sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    if (_exception) {
      struct sidl_rmi_NetworkException__object *_ex0;
      if ((_ex0 = (struct sidl_rmi_NetworkException__object *)
      sidl_PyExceptionCast(_exception, "sidl.rmi.NetworkException"))) {
        struct sidl_BaseInterface__object *throwaway_exception;
        PyObject *_obj = sidl_rmi_NetworkException__wrap(_ex0);
        PyObject *_eargs = PyTuple_New(1);
        PyTuple_SetItem(_eargs, 0, _obj);
        _obj = PyObject_CallObject(sidl_rmi_NetworkException__type, _eargs);
        PyErr_SetObject(sidl_rmi_NetworkException__type, _obj);
        Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
        Py_BEGIN_ALLOW_THREADS
        sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
        (*(_exception->d_epv->f_deleteRef))(_exception->d_object,             \
          &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
        Py_END_ALLOW_THREADS
        sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
        Py_XDECREF(_eargs);
      }
    }
    else {
      _return_value = Py_BuildValue(
        "O&",
        (void *)gov_cca_AbstractFramework__wrap, self);
    }
  }
  return _return_value;
}


#endif /*WITH_RMI*/
staticforward PyTypeObject _gov_cca_AbstractFrameworkType;

static PyObject *
pStub_AbstractFramework__dump_stats(PyObject *_self, PyObject *_args,         \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    char* filename = NULL;
    char* prefix = NULL;
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      "filename",
      "prefix",
      NULL
    };
    int _okay;
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "zz", _kwlist,
      &filename,
      &prefix);
    if (_okay) {
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f__dump_stats))(_self_ior->d_object, filename,     \
        prefix, &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct sidl_RuntimeException__object *_ex0;
        if ((_ex0 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_None;
        Py_INCREF(_return_value);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework__exec(PyObject *_self, PyObject *_args, PyObject      \
  *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    char* methodName = NULL;
    struct sidl_rmi_Call__object* inArgs = NULL;
    struct sidl_rmi_Return__object* outArgs = NULL;
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      "methodName",
      "inArgs",
      "outArgs",
      NULL
    };
    int _okay;
    sidl_RuntimeException__import();
    sidl_rmi_Call__import();
    sidl_rmi_Return__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "zO&O&", _kwlist,
      &methodName,
      (void *)sidl_rmi_Call__convert, &inArgs,
      (void *)sidl_rmi_Return__convert, &outArgs);
    if (_okay) {
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f__exec))(_self_ior->d_object, methodName, inArgs, \
        outArgs, &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct sidl_RuntimeException__object *_ex0;
        if ((_ex0 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_None;
        Py_INCREF(_return_value);
      }
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      sidl_rmi_Call_deref(inArgs);
      sidl_rmi_Return_deref(outArgs);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework__getURL(PyObject *_self, PyObject *_args, PyObject    \
  *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      NULL
    };
    int _okay;
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "", _kwlist);
    if (_okay) {
      char* _return = NULL;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      _return = (*(_self_ior->d_epv->f__getURL))(_self_ior->d_object,         \
        &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct sidl_RuntimeException__object *_ex0;
        if ((_ex0 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_BuildValue(
          "z",
          _return);
        free((void *)_return);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework__isLocal(PyObject *_self, PyObject *_args, PyObject   \
  *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      NULL
    };
    int _okay;
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "", _kwlist);
    if (_okay) {
      sidl_bool _return = (sidl_bool) 0;
      int _proxy__return;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      _return = !(*(_self_ior->d_epv->f__isRemote))(_self_ior->d_object,      \
        &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      _proxy__return = _return;
      if (_exception) {
        struct sidl_RuntimeException__object *_ex0;
        if ((_ex0 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_BuildValue(
          "i",
          _proxy__return);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework__isRemote(PyObject *_self, PyObject *_args, PyObject  \
  *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      NULL
    };
    int _okay;
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "", _kwlist);
    if (_okay) {
      sidl_bool _return = (sidl_bool) 0;
      int _proxy__return;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      _return = (*(_self_ior->d_epv->f__isRemote))(_self_ior->d_object,       \
        &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      _proxy__return = _return;
      if (_exception) {
        struct sidl_RuntimeException__object *_ex0;
        if ((_ex0 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_BuildValue(
          "i",
          _proxy__return);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework__set_contracts(PyObject *_self, PyObject *_args,      \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    sidl_bool enable = (sidl_bool) 0;
    char* enfFilename = NULL;
    sidl_bool resetCounters = (sidl_bool) 0;
    struct sidl_BaseInterface__object *_exception = NULL;
    int _proxy_enable;
    int _proxy_resetCounters;
    static char *_kwlist[] = {
      "enable",
      "enfFilename",
      "resetCounters",
      NULL
    };
    int _okay;
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "izi", _kwlist,
      &_proxy_enable,
      &enfFilename,
      &_proxy_resetCounters);
    if (_okay) {
      enable = (_proxy_enable ? (TRUE) : (FALSE));
      resetCounters = (_proxy_resetCounters ? (TRUE) : (FALSE));
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f__set_contracts))(_self_ior->d_object, enable,    \
        enfFilename, resetCounters, &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct sidl_RuntimeException__object *_ex0;
        if ((_ex0 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_None;
        Py_INCREF(_return_value);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework__set_hooks(PyObject *_self, PyObject *_args, PyObject \
  *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    sidl_bool enable = (sidl_bool) 0;
    struct sidl_BaseInterface__object *_exception = NULL;
    int _proxy_enable;
    static char *_kwlist[] = {
      "enable",
      NULL
    };
    int _okay;
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "i", _kwlist,
      &_proxy_enable);
    if (_okay) {
      enable = (_proxy_enable ? (TRUE) : (FALSE));
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f__set_hooks))(_self_ior->d_object, enable,        \
        &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct sidl_RuntimeException__object *_ex0;
        if ((_ex0 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_None;
        Py_INCREF(_return_value);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework_createEmptyFramework(PyObject *_self, PyObject *_args,\
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      NULL
    };
    int _okay;
    gov_cca_CCAException__import();
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "", _kwlist);
    if (_okay) {
      struct gov_cca_AbstractFramework__object* _return = NULL;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      _return = (*(_self_ior->d_epv->f_createEmptyFramework))(                \
        _self_ior->d_object, &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct gov_cca_CCAException__object *_ex0;
        struct sidl_RuntimeException__object *_ex1;
        if ((_ex0 = (struct gov_cca_CCAException__object *)
        sidl_PyExceptionCast(_exception, "gov.cca.CCAException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = gov_cca_CCAException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(gov_cca_CCAException__type, _eargs);
          PyErr_SetObject(gov_cca_CCAException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
        else if ((_ex1 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex1);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_BuildValue(
          "O&",
          (void *)gov_cca_AbstractFramework__wrap, _return);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework_createTypeMap(PyObject *_self, PyObject *_args,       \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      NULL
    };
    int _okay;
    gov_cca_CCAException__import();
    gov_cca_TypeMap__import();
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "", _kwlist);
    if (_okay) {
      struct gov_cca_TypeMap__object* _return = NULL;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      _return = (*(_self_ior->d_epv->f_createTypeMap))(_self_ior->d_object,   \
        &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct gov_cca_CCAException__object *_ex0;
        struct sidl_RuntimeException__object *_ex1;
        if ((_ex0 = (struct gov_cca_CCAException__object *)
        sidl_PyExceptionCast(_exception, "gov.cca.CCAException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = gov_cca_CCAException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(gov_cca_CCAException__type, _eargs);
          PyErr_SetObject(gov_cca_CCAException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
        else if ((_ex1 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex1);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_BuildValue(
          "O&",
          (void *)gov_cca_TypeMap__wrap, _return);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework_getServices(PyObject *_self, PyObject *_args,         \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    char* selfInstanceName = NULL;
    char* selfClassName = NULL;
    struct gov_cca_TypeMap__object* selfProperties = NULL;
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      "selfInstanceName",
      "selfClassName",
      "selfProperties",
      NULL
    };
    int _okay;
    gov_cca_CCAException__import();
    gov_cca_Services__import();
    gov_cca_TypeMap__import();
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "zzO&", _kwlist,
      &selfInstanceName,
      &selfClassName,
      (void *)gov_cca_TypeMap__convert, &selfProperties);
    if (_okay) {
      struct gov_cca_Services__object* _return = NULL;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      _return = (*(_self_ior->d_epv->f_getServices))(_self_ior->d_object,     \
        selfInstanceName, selfClassName, selfProperties, &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct gov_cca_CCAException__object *_ex0;
        struct sidl_RuntimeException__object *_ex1;
        if ((_ex0 = (struct gov_cca_CCAException__object *)
        sidl_PyExceptionCast(_exception, "gov.cca.CCAException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = gov_cca_CCAException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(gov_cca_CCAException__type, _eargs);
          PyErr_SetObject(gov_cca_CCAException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
        else if ((_ex1 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex1);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_BuildValue(
          "O&",
          (void *)gov_cca_Services__wrap, _return);
      }
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      gov_cca_TypeMap_deref(selfProperties);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework_releaseServices(PyObject *_self, PyObject *_args,     \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    struct gov_cca_Services__object* services = NULL;
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      "services",
      NULL
    };
    int _okay;
    gov_cca_CCAException__import();
    gov_cca_Services__import();
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "O&", _kwlist,
      (void *)gov_cca_Services__convert, &services);
    if (_okay) {
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_releaseServices))(_self_ior->d_object, services, \
        &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct gov_cca_CCAException__object *_ex0;
        struct sidl_RuntimeException__object *_ex1;
        if ((_ex0 = (struct gov_cca_CCAException__object *)
        sidl_PyExceptionCast(_exception, "gov.cca.CCAException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = gov_cca_CCAException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(gov_cca_CCAException__type, _eargs);
          PyErr_SetObject(gov_cca_CCAException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
        else if ((_ex1 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex1);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_None;
        Py_INCREF(_return_value);
      }
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      gov_cca_Services_deref(services);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static PyObject *
pStub_AbstractFramework_shutdownFramework(PyObject *_self, PyObject *_args,   \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct gov_cca_AbstractFramework__object *_self_ior =
    ((struct gov_cca_AbstractFramework__object *)
     sidl_Cast(_self, "gov.cca.AbstractFramework"));
  if (_self_ior) {
    struct sidl_BaseInterface__object *_exception = NULL;
    static char *_kwlist[] = {
      NULL
    };
    int _okay;
    gov_cca_CCAException__import();
    sidl_RuntimeException__import();
    _okay = PyArg_ParseTupleAndKeywords(
      _args, _kwdict, 
      "", _kwlist);
    if (_okay) {
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_shutdownFramework))(_self_ior->d_object,         \
        &_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      if (_exception) {
        struct gov_cca_CCAException__object *_ex0;
        struct sidl_RuntimeException__object *_ex1;
        if ((_ex0 = (struct gov_cca_CCAException__object *)
        sidl_PyExceptionCast(_exception, "gov.cca.CCAException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = gov_cca_CCAException__wrap(_ex0);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(gov_cca_CCAException__type, _eargs);
          PyErr_SetObject(gov_cca_CCAException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
        else if ((_ex1 = (struct sidl_RuntimeException__object *)
        sidl_PyExceptionCast(_exception, "sidl.RuntimeException"))) {
          struct sidl_BaseInterface__object *throwaway_exception;
          PyObject *_obj = sidl_RuntimeException__wrap(_ex1);
          PyObject *_eargs = PyTuple_New(1);
          PyTuple_SetItem(_eargs, 0, _obj);
          _obj = PyObject_CallObject(sidl_RuntimeException__type, _eargs);
          PyErr_SetObject(sidl_RuntimeException__type, _obj);
          Py_XDECREF(_obj);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_BEGIN_ALLOW_THREADS
          sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          (*(_exception->d_epv->f_deleteRef))(_exception->d_object,           \
            &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
          Py_END_ALLOW_THREADS
          sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
          Py_XDECREF(_eargs);
        }
      }
      else {
        _return_value = Py_None;
        Py_INCREF(_return_value);
      }
    }
    {
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*(_self_ior->d_epv->f_deleteRef))(_self_ior->d_object,                 \
        &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
  }
  else {
    PyErr_SetString(PyExc_TypeError, 
      "self pointer is not a gov.cca.AbstractFramework");
  }
  return _return_value;
}

static int
gov_cca_AbstractFramework_createCast(PyObject *self, PyObject *args, PyObject \
  *kwds) {
  struct gov_cca_AbstractFramework__object *optarg = NULL;
  static char *_kwlist[] = { "sobj", NULL };
  int _okay = PyArg_ParseTupleAndKeywords(args, kwds, "O&", _kwlist, (void    \
    *)gov_cca_AbstractFramework__convert, &optarg);
  if (_okay) {
    return sidl_Object_Init(
      (SPObject *)self,
      (struct sidl_BaseInterface__object *)optarg->d_object,
      sidl_PyStealRef);
  }
  return -1;
}

static PyMethodDef _AbstractFrameworkModuleMethods[] = {

#ifdef WITH_RMI

  { "_connect", (PyCFunction)pStub_AbstractFramework__connect,
  (METH_VARARGS | METH_KEYWORDS),
"\
_connect( in string url)\n\
RETURNS\n\
   ( out gov.cca.AbstractFramework self)\n\
RAISES\n\
    sidl.rmi.NetworkException\n\
"
   },

#endif /*WITH_RMI*/

  { NULL, NULL }
};

static PyMethodDef _AbstractFrameworkObjectMethods[] = {
  { "_dump_stats", (PyCFunction)pStub_AbstractFramework__dump_stats,
  (METH_VARARGS | METH_KEYWORDS),
"\
_dump_stats( in string filename,\n\
             in string prefix)\n\
RETURNS\n\
    None\n\
RAISES\n\
    sidl.RuntimeException\n\
\n\
\
Method to dump contract enforcement statistics."
   },
  { "_exec", (PyCFunction)pStub_AbstractFramework__exec,
  (METH_VARARGS | METH_KEYWORDS),
"\
_exec( in string methodName,\n\
       in sidl.rmi.Call inArgs,\n\
       in sidl.rmi.Return outArgs)\n\
RETURNS\n\
    None\n\
RAISES\n\
    sidl.RuntimeException\n\
\n\
\
Select and execute a method by name"
   },
  { "_getURL", (PyCFunction)pStub_AbstractFramework__getURL,
  (METH_VARARGS | METH_KEYWORDS),
"\
_getURL()\n\
RETURNS\n\
   (string _return)\n\
RAISES\n\
    sidl.RuntimeException\n\
\n\
\
Get the URL of the Implementation of this object (for RMI)"
   },
  { "_isLocal", (PyCFunction)pStub_AbstractFramework__isLocal,
  (METH_VARARGS | METH_KEYWORDS),
"\
_isLocal()\n\
RETURNS\n\
   (bool _return)\n\
RAISES\n\
    sidl.RuntimeException\n\
\n\
\
TRUE if this object is local, false if remote"
   },
  { "_isRemote", (PyCFunction)pStub_AbstractFramework__isRemote,
  (METH_VARARGS | METH_KEYWORDS),
"\
_isRemote()\n\
RETURNS\n\
   (bool _return)\n\
RAISES\n\
    sidl.RuntimeException\n\
\n\
\
TRUE if this object is remote, false if local"
   },
  { "_set_contracts", (PyCFunction)pStub_AbstractFramework__set_contracts,
  (METH_VARARGS | METH_KEYWORDS),
"\
_set_contracts( in bool enable,\n\
                in string enfFilename,\n\
                in bool resetCounters)\n\
RETURNS\n\
    None\n\
RAISES\n\
    sidl.RuntimeException\n\
\n\
\
Method to enable/disable interface contract enforcement."
   },
  { "_set_hooks", (PyCFunction)pStub_AbstractFramework__set_hooks,
  (METH_VARARGS | METH_KEYWORDS),
"\
_set_hooks( in bool enable)\n\
RETURNS\n\
    None\n\
RAISES\n\
    sidl.RuntimeException\n\
\n\
\
Method to enable/disable method hooks invocation."
   },
  { "createEmptyFramework", (                                                 \
    PyCFunction)pStub_AbstractFramework_createEmptyFramework,
  (METH_VARARGS | METH_KEYWORDS),
"\
createEmptyFramework()\n\
RETURNS\n\
   (gov.cca.AbstractFramework _return)\n\
RAISES\n\
    gov.cca.CCAException\n\
    sidl.RuntimeException\n\
\n\
\
 \n\
Creates a new framework instance based on the same underlying \n\
framework implementation. This does not copy the existing \n\
framework, nor are any of the user-instantiated components in\n\
the original framework available in the newly created \n\
<code>AbstractFramework</code>. \n\
\n\
@throws CCAException when one of the following conditions occur:\n\
\n\
(1)the AbstractFramework previously had shutdownFramework() called on it, or \n\
(2)the underlying framework implementation does not permit creation \n\
of another instance.\t "
   },
  { "createTypeMap", (PyCFunction)pStub_AbstractFramework_createTypeMap,
  (METH_VARARGS | METH_KEYWORDS),
"\
createTypeMap()\n\
RETURNS\n\
   (gov.cca.TypeMap _return)\n\
RAISES\n\
    gov.cca.CCAException\n\
    sidl.RuntimeException\n\
\n\
\
 \n\
Create an empty TypeMap. Presumably this would be used in \n\
an ensuing call to <code>getServices()</code>. The \"normal\" method of\n\
creating typemaps is found in the <code>Services</code> interface. It\n\
is duplicated here to break the \"chicken and egg\" problem."
   },
  { "getServices", (PyCFunction)pStub_AbstractFramework_getServices,
  (METH_VARARGS | METH_KEYWORDS),
"\
getServices( in string selfInstanceName,\n\
             in string selfClassName,\n\
             in gov.cca.TypeMap selfProperties)\n\
RETURNS\n\
   (gov.cca.Services _return)\n\
RAISES\n\
    gov.cca.CCAException\n\
    sidl.RuntimeException\n\
\n\
\
 \n\
Retrieve a Services handle to the underlying framework. \n\
This interface effectively causes the calling program to \n\
appear as the image of a component inside the framework.\n\
This method may be called any number of times\n\
with different arguments, creating a new component image \n\
each time. \n\
The only proper method to destroy a Services obtained \n\
from this interface is to pass it to releaseServices.\n\
\n\
@param selfInstanceName the Component instance name,\n\
as it will appear in the framework.\n\
\n\
@param selfClassName the Component type of the \n\
calling program, as it will appear in the framework. \n\
\n\
@param selfProperties (which can be null) the properties \n\
of the component image to appear. \n\
\n\
@throws CCAException in the event that selfInstanceName \n\
is already in use by another component.\n\
\n\
@return  A Services object that pertains to the\n\
image of the this component. This is identical\n\
to the object passed into Component.setServices() \n\
when a component is created."
   },
  { "releaseServices", (PyCFunction)pStub_AbstractFramework_releaseServices,
  (METH_VARARGS | METH_KEYWORDS),
"\
releaseServices( in gov.cca.Services services)\n\
RETURNS\n\
    None\n\
RAISES\n\
    gov.cca.CCAException\n\
    sidl.RuntimeException\n\
\n\
\
 \n\
Inform framework that the <code>Services</code> handle is no longer needed by the \n\
caller and that the reference to its component image is to be\n\
deleted from the context of the underlying framework. This invalidates\n\
any <code>ComponentID</code>'s or <code>ConnectionID</code>'s associated \n\
with the given <code>Services</code>' component image. \n\
\n\
@param services The result of getServices earlier obtained.\n\
\n\
@throws CCAException if the <code>Services</code>\n\
handle has already been released or is otherwise rendered invalid \n\
or was not obtained from <code>getServices()</code>."
   },
  { "shutdownFramework", (                                                    \
    PyCFunction)pStub_AbstractFramework_shutdownFramework,
  (METH_VARARGS | METH_KEYWORDS),
"\
shutdownFramework()\n\
RETURNS\n\
    None\n\
RAISES\n\
    gov.cca.CCAException\n\
    sidl.RuntimeException\n\
\n\
\
 \n\
Tell the framework it is no longer needed and to clean up after itself. \n\
@throws CCAException if the framework has already been shutdown."
   },
  { NULL, NULL }
};

static PyTypeObject _gov_cca_AbstractFrameworkType = {
  PyObject_HEAD_INIT(NULL)
  0,      /* ob_size */
  "gov.cca.AbstractFramework.AbstractFramework", /* tp_name */
  0,      /* tp_basicsize */
  0,      /* tp_itemsize */
  0,      /* tp_dealloc */
  0,      /* tp_print */
  0,      /* tp_getattr */
  0,      /* tp_setattr */
  0,      /* tp_compare */
  0,      /* tp_repr */
  0,      /* tp_as_number */
  0,      /* tp_as_sequence */
  0,      /* tp_as_mapping */
  0,      /* tp_hash  */
  0,      /* tp_call */
  0,      /* tp_str */
  0,      /* tp_getattro */
  0,      /* tp_setattro */
  0,      /* tp_as_buffer */
  Py_TPFLAGS_DEFAULT, /* tp_flags */
  "\
\
 \n\
This is an interface presented by a CCA-compliant framework to access its \n\
application framing capabilities. Most of the manipulation of the \n\
underlying framework is expected to be be done with the \n\
gov.cca.BuilderService Port. This class exists as a sort of bootstrap \n\
to get a Services object necessary to retrieve Port's, including \n\
BuilderService, from the underlying framework. How the interface and \n\
the underlying framework is created is entirely unspecified and is up \n\
to the devices of the programmer and the framework provider.\n\
\n\
<p>Example</p>\n\
<p>\n\
Here it is assumed that an instance of AbstractFramework\n\
is created in the main() from some hypothetical implementation.\n\
The idea is to allow a complete swap of framework choice by \n\
changing out the specified implementation class of a framework.\n\
</p>\n\
\n\
<code><pre>\n\
// java\n\
main() {\n\
cca.reference.Framework fwkimpl = new cca.reference.Framework();\n\
// change fwkimpl above to use different cca implementations when\n\
// AbstractFramework becomes part of the standard.\n\
gov.cca.AbstractFramework fwk = (gov.cca.AbstractFramework)fwkimpl;\n\
gov.cca.Services svc = \n\
fwk.getServices(\"instance0\",\"AppDriver\",null);\n\
// From here on, access all services, components, etc\n\
// through svc.\n\
...\n\
// when done\n\
fwk.releaseServices(svc);\n\
fwk.shutdownFramework();\n\
}\n\
\n\
// c++\n\
int functionName() {\n\
::gov::sandia::ccafe::Framework fwkimpl;\n\
::gov::cca::AbstractFrameworkPtr fwk;\n\
\n\
fwk = fwkimpl.getStandardFramework();\n\
::gov::cca::Services_Interface  svc = 0;\n\
svc = fwk->getServices(\"instance0\",\"AppDriver\",0);\n\
// From here on, access all services, components, etc\n\
// through svc.\n\
...\n\
// when done\n\
fwk->releaseServices(svc);\n\
svc = 0;\n\
fwk->shutdownFramework();\n\
\n\
// at scope exit, all memory is automatically cleaned up.\n\
}\n\
</pre></code>", /* tp_doc */
  0,      /* tp_traverse */
  0,       /* tp_clear */
  0,       /* tp_richcompare */
  0,       /* tp_weaklistoffset */
  0,       /* tp_iter */
  0,       /* tp_iternext */
  _AbstractFrameworkObjectMethods, /* tp_methods */
  0,       /* tp_members */
  0,       /* tp_getset */
  0,       /* tp_base */
  0,       /* tp_dict */
  0,       /* tp_descr_get */
  0,       /* tp_descr_set */
  0,       /* tp_dictoffset */
  gov_cca_AbstractFramework_createCast,   /* tp_init */
  0,       /* tp_alloc */
  0,       /* tp_new */
};

gov_cca_AbstractFramework__wrap_RETURN
gov_cca_AbstractFramework__wrap gov_cca_AbstractFramework__wrap_PROTO {
  PyObject *result;
  if (sidlobj) {
    result = _gov_cca_AbstractFrameworkType.tp_new(                           \
      &_gov_cca_AbstractFrameworkType, NULL, NULL);
    if (result) {
      if (sidl_Object_Init(
        (SPObject *)result,
        (struct sidl_BaseInterface__object *)(sidlobj->d_object),
        sidl_PyStealRef))
      {
        Py_DECREF(result);
        result = NULL;
      }
    }
  }
  else {
    result = Py_None;
    Py_INCREF(result);
  }
  return result;
}

gov_cca_AbstractFramework__weakRef_RETURN
gov_cca_AbstractFramework__weakRef gov_cca_AbstractFramework__weakRef_PROTO {
  PyObject *result;
  if (sidlobj) {
    result = _gov_cca_AbstractFrameworkType.tp_new(                           \
      &_gov_cca_AbstractFrameworkType, NULL, NULL);
    if (result) {
      if (sidl_Object_Init(
        (SPObject *)result,
        (struct sidl_BaseInterface__object *)(sidlobj->d_object),
        sidl_PyWeakRef))
      {
        Py_DECREF(result);
        result = NULL;
      }
    }
  }
  else {
    result = Py_None;
    Py_INCREF(result);
  }
  return result;
}

gov_cca_AbstractFramework_deref_RETURN
gov_cca_AbstractFramework_deref gov_cca_AbstractFramework_deref_PROTO {
  if (sidlobj) {
    struct sidl_BaseInterface__object *throwaway_exception;
    (*(sidlobj->d_epv->f_deleteRef))(sidlobj->d_object, &throwaway_exception);
  }
}

gov_cca_AbstractFramework__newRef_RETURN
gov_cca_AbstractFramework__newRef gov_cca_AbstractFramework__newRef_PROTO {
  PyObject *result;
  if (sidlobj) {
    result = _gov_cca_AbstractFrameworkType.tp_new(                           \
      &_gov_cca_AbstractFrameworkType, NULL, NULL);
    if (result) {
      if (sidl_Object_Init(
        (SPObject *)result,
        (struct sidl_BaseInterface__object *)(sidlobj->d_object),
        sidl_PyNewRef))
      {
        Py_DECREF(result);
        result = NULL;
      }
    }
  }
  else {
    result = Py_None;
    Py_INCREF(result);
  }
  return result;
}

gov_cca_AbstractFramework__addRef_RETURN
gov_cca_AbstractFramework__addRef gov_cca_AbstractFramework__addRef_PROTO {
  if (sidlobj) {
    struct sidl_BaseInterface__object *throwaway_exception;
    (*(sidlobj->d_epv->f_addRef))(sidlobj->d_object, &throwaway_exception);
  }
}

gov_cca_AbstractFramework_PyType_RETURN
gov_cca_AbstractFramework_PyType gov_cca_AbstractFramework_PyType_PROTO {
  Py_INCREF(&_gov_cca_AbstractFrameworkType);
  return &_gov_cca_AbstractFrameworkType;
}

gov_cca_AbstractFramework__convert_RETURN
gov_cca_AbstractFramework__convert gov_cca_AbstractFramework__convert_PROTO {
  if (*sidlobj) {
    struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
    Py_BEGIN_ALLOW_THREADS
    sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    (*((*sidlobj)->d_epv->f_deleteRef))((*sidlobj)->d_object,                 \
      &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
    Py_END_ALLOW_THREADS
    sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
  }
  *sidlobj = sidl_Cast(obj, "gov.cca.AbstractFramework");
  if ((!(*sidlobj)) && (obj != Py_None)) {
    PyErr_SetString(PyExc_TypeError, 
      "argument is not a(n) gov.cca.AbstractFramework");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj)
{
  struct gov_cca_AbstractFramework__object *sidlobj = NULL;
  if (gov_cca_AbstractFramework__convert(pyobj, &sidlobj)) {
    sidl_interface__array_set((struct sidl_interface__array *)sidlarray,
    ind, (struct sidl_BaseInterface__object *)sidlobj);
    if (sidlobj) {
      struct sidl_BaseInterface__object *asInt = (struct                      \
        sidl_BaseInterface__object *)sidlobj;
      struct sidl_BaseInterface__object *throwaway_exception;
#if (PY_VERSION_HEX >= 0x02040000)
      Py_BEGIN_ALLOW_THREADS
      sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
      (*asInt->d_epv->f_deleteRef)(asInt->d_object, &throwaway_exception);
#if (PY_VERSION_HEX >= 0x02040000)
      Py_END_ALLOW_THREADS
      sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    }
    return FALSE;
  }
  return TRUE;
}

gov_cca_AbstractFramework__convert_python_array_RETURN
gov_cca_AbstractFramework__convert_python_array                               \
  gov_cca_AbstractFramework__convert_python_array_PROTO {
  int result = 0;
  if (*sidlarray) {
#if (PY_VERSION_HEX >= 0x02040000)
    Py_BEGIN_ALLOW_THREADS
    sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    sidl__array_deleteRef((struct sidl__array *)*sidlarray);
#if (PY_VERSION_HEX >= 0x02040000)
    Py_END_ALLOW_THREADS
    sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
    *sidlarray = NULL;
  }
  if (obj == Py_None) {
    result = TRUE;
  }
  else {
    PyObject *pya = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
    if (pya) {
      if (PyArray_OBJECT == ((PyArrayObject *)pya)->descr->type_num) {
        int dimen, lower[SIDL_MAX_ARRAY_DIMENSION],
          upper[SIDL_MAX_ARRAY_DIMENSION],
          stride[SIDL_MAX_ARRAY_DIMENSION];
        if (sidl_array__extract_python_info
          (pya, &dimen, lower, upper, stride))
        {
            *sidlarray = (struct                                              \
              gov_cca_AbstractFramework__array*)sidl_interface__array_createRow
            (dimen, lower, upper);
          result = sidl_array__convert_python
            (pya, dimen, *sidlarray, _convertPython);
          if (*sidlarray && !result) {
#if (PY_VERSION_HEX >= 0x02040000)
            Py_BEGIN_ALLOW_THREADS
            sidl_Python_LogUnlock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
            sidl_interface__array_deleteRef(
              (struct  sidl_interface__array *)*sidlarray);
#if (PY_VERSION_HEX >= 0x02040000)
            Py_END_ALLOW_THREADS
            sidl_Python_LogRelock(__func__, __FILE__, __LINE__);
#endif /* Python 2.4 or later */
            *sidlarray = NULL;
          }
        }
      }
      Py_DECREF(pya);
    }
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest)
{
  struct gov_cca_AbstractFramework__object *sidlobj = (struct                 \
    gov_cca_AbstractFramework__object*)
  sidl_interface__array_get((struct sidl_interface__array *)
    sidlarray, ind);
  *dest = gov_cca_AbstractFramework__wrap(sidlobj);
  return (*dest == NULL);
}

gov_cca_AbstractFramework__convert_sidl_array_RETURN
gov_cca_AbstractFramework__convert_sidl_array                                 \
  gov_cca_AbstractFramework__convert_sidl_array_PROTO {
  PyObject *pya = NULL;
  if (sidlarray) {
    const int dimen = sidlArrayDim(sidlarray);
#ifdef SIDL_HAVE_NUMPY
    npy_intp numelem[7];
#else
    int numelem[7];
#endif
    int32_t start[7];
    int32_t s_numelem[7];
#if SIZEOF_INT != 4
    int lower[7];
    int upper[7];
#else
    int * const lower = (int *)(sidlarray->d_lower);
    int * const upper = (int *)(sidlarray->d_upper);
#endif
    int i;
    for(i = 0; i < dimen; ++i) {
      start[i] = sidlLower(sidlarray, i);
#if SIZEOF_INT != 4
      lower[i] = sidlLower(sidlarray, i);
      upper[i] = sidlUpper(sidlarray, i);
#endif
      s_numelem[i] = sidlLength(sidlarray, i);
      numelem[i] = 1 + upper[i] - lower[i];
    }
#ifdef SIDL_HAVE_NUMPY
    pya = PyArray_SimpleNew(dimen, numelem, PyArray_OBJECT);
#else
#ifdef SIDL_HAVE_NUMERIC
    pya = PyArray_FromDims(dimen, numelem, PyArray_OBJECT);
#else
#error Neither NumPy nor Numeric installed
#endif
#endif
    if (pya) {
      if (!sidl_array__convert_sidl(pya, dimen, start,
        sidlarray->d_upper,
        s_numelem, sidlarray, _convertSIDL))
      {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
  }
  else {
    Py_INCREF(Py_None);
    pya = Py_None;
  }
  return pya;
}

void
initAbstractFramework(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[gov_cca_AbstractFramework__API_NUM];
  struct sidl_BaseInterface__object *throwaway_exception;
  module = Py_InitModule3("AbstractFramework",                                \
    _AbstractFrameworkModuleMethods, "\
\
 \n\
This is an interface presented by a CCA-compliant framework to access its \n\
application framing capabilities. Most of the manipulation of the \n\
underlying framework is expected to be be done with the \n\
gov.cca.BuilderService Port. This class exists as a sort of bootstrap \n\
to get a Services object necessary to retrieve Port's, including \n\
BuilderService, from the underlying framework. How the interface and \n\
the underlying framework is created is entirely unspecified and is up \n\
to the devices of the programmer and the framework provider.\n\
\n\
<p>Example</p>\n\
<p>\n\
Here it is assumed that an instance of AbstractFramework\n\
is created in the main() from some hypothetical implementation.\n\
The idea is to allow a complete swap of framework choice by \n\
changing out the specified implementation class of a framework.\n\
</p>\n\
\n\
<code><pre>\n\
// java\n\
main() {\n\
cca.reference.Framework fwkimpl = new cca.reference.Framework();\n\
// change fwkimpl above to use different cca implementations when\n\
// AbstractFramework becomes part of the standard.\n\
gov.cca.AbstractFramework fwk = (gov.cca.AbstractFramework)fwkimpl;\n\
gov.cca.Services svc = \n\
fwk.getServices(\"instance0\",\"AppDriver\",null);\n\
// From here on, access all services, components, etc\n\
// through svc.\n\
...\n\
// when done\n\
fwk.releaseServices(svc);\n\
fwk.shutdownFramework();\n\
}\n\
\n\
// c++\n\
int functionName() {\n\
::gov::sandia::ccafe::Framework fwkimpl;\n\
::gov::cca::AbstractFrameworkPtr fwk;\n\
\n\
fwk = fwkimpl.getStandardFramework();\n\
::gov::cca::Services_Interface  svc = 0;\n\
svc = fwk->getServices(\"instance0\",\"AppDriver\",0);\n\
// From here on, access all services, components, etc\n\
// through svc.\n\
...\n\
// when done\n\
fwk->releaseServices(svc);\n\
svc = 0;\n\
fwk->shutdownFramework();\n\
\n\
// at scope exit, all memory is automatically cleaned up.\n\
}\n\
</pre></code>"
  );
  dict = PyModule_GetDict(module);
  ExternalAPI[gov_cca_AbstractFramework__wrap_NUM] = (                        \
    void*)gov_cca_AbstractFramework__wrap;
  ExternalAPI[gov_cca_AbstractFramework__convert_NUM] = (                     \
    void*)gov_cca_AbstractFramework__convert;
  ExternalAPI[gov_cca_AbstractFramework__convert_python_array_NUM] = (        \
    void*)gov_cca_AbstractFramework__convert_python_array;
  ExternalAPI[gov_cca_AbstractFramework__convert_sidl_array_NUM] = (          \
    void*)gov_cca_AbstractFramework__convert_sidl_array;
  ExternalAPI[gov_cca_AbstractFramework__weakRef_NUM] = (                     \
    void*)gov_cca_AbstractFramework__weakRef;
  ExternalAPI[gov_cca_AbstractFramework_deref_NUM] = (                        \
    void*)gov_cca_AbstractFramework_deref;
  ExternalAPI[gov_cca_AbstractFramework__newRef_NUM] = (                      \
    void*)gov_cca_AbstractFramework__newRef;
  ExternalAPI[gov_cca_AbstractFramework__addRef_NUM] = (                      \
    void*)gov_cca_AbstractFramework__addRef;
  ExternalAPI[gov_cca_AbstractFramework_PyType_NUM] = (                       \
    void*)gov_cca_AbstractFramework_PyType;
#ifdef WITH_RMI
  ExternalAPI[gov_cca_AbstractFramework__connectI_NUM] = (                    \
    void*)gov_cca_AbstractFramework__connectI;
#endif /*WITH_RMI*/
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    Py_FatalError("Error importing sidlObjA module.");
  }
  c_api = PyCObject_FromVoidPtr((void *)ExternalAPI, NULL);
  PyDict_SetItemString(dict, "_C_API", c_api);
  Py_XDECREF(c_api);
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    Py_FatalError("Error importing sidlPyArrays module.");
  }
  import_array();
  if (PyErr_Occurred()) {
    Py_FatalError("Error importing Numeric Python module.");
  }
  sidl_BaseInterface__import();
  _gov_cca_AbstractFrameworkType.tp_base = sidl_BaseInterface_PyType();
  _gov_cca_AbstractFrameworkType.tp_bases = PyTuple_New(1);
  PyTuple_SetItem(_gov_cca_AbstractFrameworkType.tp_bases,0, (PyObject        \
    *)sidl_BaseInterface_PyType());
  if (PyType_Ready(&_gov_cca_AbstractFrameworkType) < 0) {
    PyErr_Print();
    fprintf(stderr, "PyType_Ready on gov.cca.AbstractFramework failed.\n");
    return;
  }
  Py_INCREF(&_gov_cca_AbstractFrameworkType);
  PyDict_SetItemString(dict, "AbstractFramework", (PyObject                   \
    *)&_gov_cca_AbstractFrameworkType);

#ifdef WITH_RMI


  sidl_rmi_ConnectRegistry_registerConnect("gov.cca.AbstractFramework", (     \
    void*)gov_cca_AbstractFramework__IHConnect, &throwaway_exception);

#endif /*WITH_RMI*/

}
