/*
 * File:          gov_cca_AbstractFramework_IOR.h
 * Symbol:        gov.cca.AbstractFramework-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   Intermediate Object Representation for gov.cca.AbstractFramework
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

#ifndef included_gov_cca_AbstractFramework_IOR_h
#define included_gov_cca_AbstractFramework_IOR_h

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
struct sidl_rmi_InstanceHandle__object;
#ifndef included_sidl_BaseInterface_IOR_h
#include "sidl_BaseInterface_IOR.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Symbol "gov.cca.AbstractFramework" (version 0.8.5)
 * 
 *  
 * This is an interface presented by a CCA-compliant framework to access its 
 * application framing capabilities. Most of the manipulation of the 
 * underlying framework is expected to be be done with the 
 * gov.cca.BuilderService Port. This class exists as a sort of bootstrap 
 * to get a Services object necessary to retrieve Port's, including 
 * BuilderService, from the underlying framework. How the interface and 
 * the underlying framework is created is entirely unspecified and is up 
 * to the devices of the programmer and the framework provider.
 * 
 * <p>Example</p>
 * <p>
 * Here it is assumed that an instance of AbstractFramework
 * is created in the main() from some hypothetical implementation.
 * The idea is to allow a complete swap of framework choice by 
 * changing out the specified implementation class of a framework.
 * </p>
 * 
 * <code><pre>
 * // java
 * main() {
 * cca.reference.Framework fwkimpl = new cca.reference.Framework();
 * // change fwkimpl above to use different cca implementations when
 * // AbstractFramework becomes part of the standard.
 * gov.cca.AbstractFramework fwk = (gov.cca.AbstractFramework)fwkimpl;
 * gov.cca.Services svc = 
 * fwk.getServices("instance0","AppDriver",null);
 * // From here on, access all services, components, etc
 * // through svc.
 * ...
 * // when done
 * fwk.releaseServices(svc);
 * fwk.shutdownFramework();
 * }
 * 
 * // c++
 * int functionName() {
 * ::gov::sandia::ccafe::Framework fwkimpl;
 * ::gov::cca::AbstractFrameworkPtr fwk;
 * 
 * fwk = fwkimpl.getStandardFramework();
 * ::gov::cca::Services_Interface  svc = 0;
 * svc = fwk->getServices("instance0","AppDriver",0);
 * // From here on, access all services, components, etc
 * // through svc.
 * ...
 * // when done
 * fwk->releaseServices(svc);
 * svc = 0;
 * fwk->shutdownFramework();
 * 
 * // at scope exit, all memory is automatically cleaned up.
 * }
 * </pre></code>
 */

struct gov_cca_AbstractFramework__array;
struct gov_cca_AbstractFramework__object;

/*
 * Forward references for external classes and interfaces.
 */

struct gov_cca_CCAException__array;
struct gov_cca_CCAException__object;
struct gov_cca_Services__array;
struct gov_cca_Services__object;
struct gov_cca_TypeMap__array;
struct gov_cca_TypeMap__object;
struct sidl_BaseException__array;
struct sidl_BaseException__object;
struct sidl_ClassInfo__array;
struct sidl_ClassInfo__object;
struct sidl_RuntimeException__array;
struct sidl_RuntimeException__object;
struct sidl_rmi_Call__array;
struct sidl_rmi_Call__object;
struct sidl_rmi_Return__array;
struct sidl_rmi_Return__object;

/*
 * Declare the method entry point vector.
 */

struct gov_cca_AbstractFramework__epv {
  /* Implicit builtin methods */
  /* 0 */
  void* (*f__cast)(
    /* in */ void* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 1 */
  void (*f__delete)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 2 */
  void (*f__exec)(
    /* in */ void* self,
    /* in */ const char* methodName,
    /* in */ struct sidl_rmi_Call__object* inArgs,
    /* in */ struct sidl_rmi_Return__object* outArgs,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 3 */
  char* (*f__getURL)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 4 */
  void (*f__raddRef)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 5 */
  sidl_bool (*f__isRemote)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 6 */
  void (*f__set_hooks)(
    /* in */ void* self,
    /* in */ sidl_bool enable,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 7 */
  void (*f__set_contracts)(
    /* in */ void* self,
    /* in */ sidl_bool enable,
    /* in */ const char* enfFilename,
    /* in */ sidl_bool resetCounters,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 8 */
  void (*f__dump_stats)(
    /* in */ void* self,
    /* in */ const char* filename,
    /* in */ const char* prefix,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in sidl.BaseInterface-v0.9.17 */
  void (*f_addRef)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_deleteRef)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f_isSame)(
    /* in */ void* self,
    /* in */ struct sidl_BaseInterface__object* iobj,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f_isType)(
    /* in */ void* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object **_ex);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in gov.cca.AbstractFramework-v0.8.5 */
  struct gov_cca_TypeMap__object* (*f_createTypeMap)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  struct gov_cca_Services__object* (*f_getServices)(
    /* in */ void* self,
    /* in */ const char* selfInstanceName,
    /* in */ const char* selfClassName,
    /* in */ struct gov_cca_TypeMap__object* selfProperties,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_releaseServices)(
    /* in */ void* self,
    /* in */ struct gov_cca_Services__object* services,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_shutdownFramework)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  struct gov_cca_AbstractFramework__object* (*f_createEmptyFramework)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
};

/*
 * Declare the method pre hooks entry point vector.
 */

struct gov_cca_AbstractFramework__pre_epv {
  void (*f_createTypeMap_pre)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_getServices_pre)(
    /* in */ void* self,
    /* in */ const char* selfInstanceName,
    /* in */ const char* selfClassName,
    /* in */ struct gov_cca_TypeMap__object* selfProperties,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_releaseServices_pre)(
    /* in */ void* self,
    /* in */ struct gov_cca_Services__object* services,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_shutdownFramework_pre)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_createEmptyFramework_pre)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
};

/*
 * Declare the method post hooks entry point vector.
 */

struct gov_cca_AbstractFramework__post_epv {
  void (*f_createTypeMap_post)(
    /* in */ void* self,
    /* in */ struct gov_cca_TypeMap__object* _retval,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_getServices_post)(
    /* in */ void* self,
    /* in */ const char* selfInstanceName,
    /* in */ const char* selfClassName,
    /* in */ struct gov_cca_TypeMap__object* selfProperties,
    /* in */ struct gov_cca_Services__object* _retval,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_releaseServices_post)(
    /* in */ void* self,
    /* in */ struct gov_cca_Services__object* services,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_shutdownFramework_post)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_createEmptyFramework_post)(
    /* in */ void* self,
    /* in */ struct gov_cca_AbstractFramework__object* _retval,
    /* out */ struct sidl_BaseInterface__object **_ex);
};

/*
 * Define the interface object structure.
 */

struct gov_cca_AbstractFramework__object {
  struct gov_cca_AbstractFramework__epv* d_epv;
  void*                                  d_object;
};

/**
 * 
 * 
 * Anonymous class definition
 * 
 * 
 */
/*
 * Symbol "gov.cca._AbstractFramework" (version 1.0)
 */

struct gov_cca__AbstractFramework__array;
struct gov_cca__AbstractFramework__object;

/*
 * Declare the method entry point vector.
 */

struct gov_cca__AbstractFramework__epv {
  /* Implicit builtin methods */
  void* (*f__cast)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__delete)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__exec)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ const char* methodName,
    /* in */ struct sidl_rmi_Call__object* inArgs,
    /* in */ struct sidl_rmi_Return__object* outArgs,
    /* out */ struct sidl_BaseInterface__object **_ex);
  char* (*f__getURL)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__raddRef)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f__isRemote)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__set_hooks)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ sidl_bool enable,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__set_contracts)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ sidl_bool enable,
    /* in */ const char* enfFilename,
    /* in */ sidl_bool resetCounters,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__dump_stats)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ const char* filename,
    /* in */ const char* prefix,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__ctor)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__ctor2)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ void* private_data,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__dtor)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in sidl.BaseInterface-v0.9.17 */
  void (*f_addRef)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_deleteRef)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f_isSame)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ struct sidl_BaseInterface__object* iobj,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f_isType)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object **_ex);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in gov.cca.AbstractFramework-v0.8.5 */
  struct gov_cca_TypeMap__object* (*f_createTypeMap)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  struct gov_cca_Services__object* (*f_getServices)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ const char* selfInstanceName,
    /* in */ const char* selfClassName,
    /* in */ struct gov_cca_TypeMap__object* selfProperties,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_releaseServices)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* in */ struct gov_cca_Services__object* services,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_shutdownFramework)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  struct gov_cca_AbstractFramework__object* (*f_createEmptyFramework)(
    /* in */ struct gov_cca__AbstractFramework__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in gov.cca._AbstractFramework-v1.0 */
};

/*
 * Define the controls and statistics structure.
 */


struct gov_cca__AbstractFramework__cstats {
  sidl_bool use_hooks;
};

/*
 * Define the class object structure.
 */

struct gov_cca__AbstractFramework__object {
  struct gov_cca_AbstractFramework__object d_gov_cca_abstractframework;
  struct sidl_BaseInterface__object        d_sidl_baseinterface;
  struct gov_cca__AbstractFramework__epv*  d_epv;
  void*                                    d_data;
};


struct gov_cca__AbstractFramework__remote{
  int d_refcount;
  struct sidl_rmi_InstanceHandle__object *d_ih;
};

#ifdef __cplusplus
}
#endif
#endif
