/*
 * File:          gov_cca_ports_ParameterGetListener_IOR.h
 * Symbol:        gov.cca.ports.ParameterGetListener-v0.8.5
 * Symbol Type:   interface
 * Babel Version: 1.4.0
 * Description:   Intermediate Object Representation for gov.cca.ports.ParameterGetListener
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

#ifndef included_gov_cca_ports_ParameterGetListener_IOR_h
#define included_gov_cca_ports_ParameterGetListener_IOR_h

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
struct sidl_rmi_InstanceHandle__object;
#ifndef included_sidl_BaseInterface_IOR_h
#include "sidl_BaseInterface_IOR.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Symbol "gov.cca.ports.ParameterGetListener" (version 0.8.5)
 * 
 *  This interface is typically implemented by a 
 * component writer using the ParameterPortFactory
 * in a very dynamic fashion. Most component writers don't
 * need it.
 * 
 * The ParameterGet listeners are called when
 * the readMap function is called on
 * the ParameterPort interface. 
 * The listener (usually the component owning the typemap) can change the 
 * contents (title, groups, parameters) of the ParameterPort
 * in their updateParameterPort function. These changed
 * values will be returned to the caller (framework/gui).
 * 
 * This is handy when the contents of one ParameterPort depend
 * on values already set in another ParameterPort
 * on the same component. E.g. selection of a particular chemical
 * reaction mechanism in the first ParameterPort defines the
 * set of chemical species that need initial-concentrations defined
 * in the second ParameterPort.
 * 
 * The fact that looking at a ParameterPort
 * gives an opportunity for it to change will lead to Heisenbugs
 * in the hands of an inept programmer.
 * 
 * The name of the parameter port which is being used is passed
 * so the component using the ParameterPortFactory to manage more 
 * than one Parameter port can tell which one is being updated.
 * 
 * The component should return TRUE if the contents of the
 * parameter port were changed (cleared or added to) in the
 * update function or if the component wants to receive all fresh input
 * for current values.
 * 
 * @see ParameterSetListener
 */

struct gov_cca_ports_ParameterGetListener__array;
struct gov_cca_ports_ParameterGetListener__object;

/*
 * Forward references for external classes and interfaces.
 */

struct sidl_BaseException__array;
struct sidl_BaseException__object;
struct sidl_ClassInfo__array;
struct sidl_ClassInfo__object;
struct sidl_RuntimeException__array;
struct sidl_RuntimeException__object;
struct sidl_rmi_Call__array;
struct sidl_rmi_Call__object;
struct sidl_rmi_Return__array;
struct sidl_rmi_Return__object;

/*
 * Declare the method entry point vector.
 */

struct gov_cca_ports_ParameterGetListener__epv {
  /* Implicit builtin methods */
  /* 0 */
  void* (*f__cast)(
    /* in */ void* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 1 */
  void (*f__delete)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 2 */
  void (*f__exec)(
    /* in */ void* self,
    /* in */ const char* methodName,
    /* in */ struct sidl_rmi_Call__object* inArgs,
    /* in */ struct sidl_rmi_Return__object* outArgs,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 3 */
  char* (*f__getURL)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 4 */
  void (*f__raddRef)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 5 */
  sidl_bool (*f__isRemote)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 6 */
  void (*f__set_hooks)(
    /* in */ void* self,
    /* in */ sidl_bool enable,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 7 */
  void (*f__set_contracts)(
    /* in */ void* self,
    /* in */ sidl_bool enable,
    /* in */ const char* enfFilename,
    /* in */ sidl_bool resetCounters,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* 8 */
  void (*f__dump_stats)(
    /* in */ void* self,
    /* in */ const char* filename,
    /* in */ const char* prefix,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in sidl.BaseInterface-v0.9.17 */
  void (*f_addRef)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_deleteRef)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f_isSame)(
    /* in */ void* self,
    /* in */ struct sidl_BaseInterface__object* iobj,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f_isType)(
    /* in */ void* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object **_ex);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in gov.cca.ports.ParameterGetListener-v0.8.5 */
  sidl_bool (*f_updateParameterPort)(
    /* in */ void* self,
    /* in */ const char* portName,
    /* out */ struct sidl_BaseInterface__object **_ex);
};

/*
 * Declare the method pre hooks entry point vector.
 */

struct gov_cca_ports_ParameterGetListener__pre_epv {
  void (*f_updateParameterPort_pre)(
    /* in */ void* self,
    /* in */ const char* portName,
    /* out */ struct sidl_BaseInterface__object **_ex);
};

/*
 * Declare the method post hooks entry point vector.
 */

struct gov_cca_ports_ParameterGetListener__post_epv {
  void (*f_updateParameterPort_post)(
    /* in */ void* self,
    /* in */ const char* portName,
    /* in */ sidl_bool _retval,
    /* out */ struct sidl_BaseInterface__object **_ex);
};

/*
 * Define the interface object structure.
 */

struct gov_cca_ports_ParameterGetListener__object {
  struct gov_cca_ports_ParameterGetListener__epv* d_epv;
  void*                                           d_object;
};

/**
 * 
 * 
 * Anonymous class definition
 * 
 * 
 */
/*
 * Symbol "gov.cca.ports._ParameterGetListener" (version 1.0)
 */

struct gov_cca_ports__ParameterGetListener__array;
struct gov_cca_ports__ParameterGetListener__object;

/*
 * Declare the method entry point vector.
 */

struct gov_cca_ports__ParameterGetListener__epv {
  /* Implicit builtin methods */
  void* (*f__cast)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__delete)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__exec)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ const char* methodName,
    /* in */ struct sidl_rmi_Call__object* inArgs,
    /* in */ struct sidl_rmi_Return__object* outArgs,
    /* out */ struct sidl_BaseInterface__object **_ex);
  char* (*f__getURL)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__raddRef)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f__isRemote)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__set_hooks)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ sidl_bool enable,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__set_contracts)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ sidl_bool enable,
    /* in */ const char* enfFilename,
    /* in */ sidl_bool resetCounters,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__dump_stats)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ const char* filename,
    /* in */ const char* prefix,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__ctor)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__ctor2)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ void* private_data,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f__dtor)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in sidl.BaseInterface-v0.9.17 */
  void (*f_addRef)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  void (*f_deleteRef)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f_isSame)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ struct sidl_BaseInterface__object* iobj,
    /* out */ struct sidl_BaseInterface__object **_ex);
  sidl_bool (*f_isType)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ const char* name,
    /* out */ struct sidl_BaseInterface__object **_ex);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in gov.cca.ports.ParameterGetListener-v0.8.5 */
  sidl_bool (*f_updateParameterPort)(
    /* in */ struct gov_cca_ports__ParameterGetListener__object* self,
    /* in */ const char* portName,
    /* out */ struct sidl_BaseInterface__object **_ex);
  /* Methods introduced in gov.cca.ports._ParameterGetListener-v1.0 */
};

/*
 * Define the controls and statistics structure.
 */


struct gov_cca_ports__ParameterGetListener__cstats {
  sidl_bool use_hooks;
};

/*
 * Define the class object structure.
 */

struct gov_cca_ports__ParameterGetListener__object {
  struct gov_cca_ports_ParameterGetListener__object 
    d_gov_cca_ports_parametergetlistener;
  struct sidl_BaseInterface__object                 d_sidl_baseinterface;
  struct gov_cca_ports__ParameterGetListener__epv*  d_epv;
  void*                                             d_data;
};


struct gov_cca_ports__ParameterGetListener__remote{
  int d_refcount;
  struct sidl_rmi_InstanceHandle__object *d_ih;
};

#ifdef __cplusplus
}
#endif
#endif
